package uk.ac.derby.lpt.sili2.machine;

public interface Representation {

	String stringValue();

	boolean booleanValue();
	
	double floatValue();
	
	long longValue();
	
	public int compare(Representation v);
	
	public Representation or(Representation v);

	public Representation and(Representation v);

	public Representation not();
	
	public Representation add(Representation v);

	public Representation subtract(Representation v);

	public Representation mult(Representation v);

	public Representation div(Representation v);

	public Representation unary_plus();

	public Representation unary_minus();
	
	public Representation concatenate(Representation v);

	void write();
		
}
