package uk.ac.derby.lpt.sili2.types;

import uk.ac.derby.lpt.sili2.interpreter.Value;

public class TypeString extends TypeAbstract {

	static Type thisInstance = new TypeString();
	
	protected TypeString() {
	}
	
	public static Type getInstance() {
		return thisInstance;
	}
	
	@Override
	public String getName() {
		return "string";
	}
	
	/** Add performs string concatenation. */
	public Value add(Value v1, Value v2) {
		return new Value(getInstance(), v1.getRepresentation().concatenate(v2.getRepresentation()));
	}

}
